UVA-1604 Cubic Eight-Puzzle (双向BFS+状态压缩+限制搜索层数)

题目大意:立体的八数码问题,一次操作是滚动一次方块,问从初始状态到目标状态的最少滚动次数。

题目分析:这道题已知初始状态和目标状态,且又状态数目庞大,适宜用双向BFS。每个小方块有6种状态,整个大方格有9*6^8个状态。每个小方块用一位6进制数表示即可。

注意:状态转移时要谨慎,否则会出现意想不到的错误;

   这道题的末状态有256(2^8)个,如果对搜索层数不加限制,即使双向BFS也会TLE的,当限制正向搜索15层逆向搜索15层至正向搜索27层反向搜索3层时都能AC(我下面贴出的程序是这样的),其中正向搜21层,逆向搜9层时在时间上最高效;

   对于这道题,开辟一个恰当大小的标记数组也能使时间降低一大截;

代码如下:

# include<iostream>
# include<cstdio>
# include<cmath>
# include<map>
# include<queue>
# include<cstring>
# include<algorithm>
using namespace std;

struct Node
{
    int t,n,s;
    Node(int _t,int _n,int _s):t(_t),n(_n),s(_s){}
    bool operator < (const Node &a) const {
        return t>a.t;
    }
};

map<char,int>mp;
int ss[8]={1,6,36,216,1296,7776,46656,279936};
int goal[9],path[9],vis[9][1679616],dist[9][1679616];
int d[4][2]={{1,0},{-1,0},{0,-1},{0,1}};
int p[6][4]={
    {2,2,5,5},
    {4,4,3,3},
    {0,0,4,4},
    {5,5,1,1},
    {1,1,2,2},
    {3,3,0,0},
};
priority_queue<Node>q[2];

void dfs(int u,int gp)
{
    if(u==9){
        int sta=0,cnt=0;
        for(int i=0;i<9;++i)
            if(path[i]!=-1){
                sta=sta+ss[7-cnt]*path[i];
                ++cnt;
            }
        dist[gp][sta]=0;
        vis[gp][sta]=1;
        q[1].push(Node(0,gp,sta));
        return ;
    }
    if(goal[u]==1){
        path[u]=0;
        dfs(u+1,gp);
        path[u]=1;
        dfs(u+1,gp);
    }else if(goal[u]==2){
        path[u]=2;
        dfs(u+1,gp);
        path[u]=3;
        dfs(u+1,gp);
    }else if(goal[u]==3){
        path[u]=4;
        dfs(u+1,gp);
        path[u]=5;
        dfs(u+1,gp);
    }else{
        path[u]=-1;
        dfs(u+1,gp);
    }
}

void init(int x,int y)
{
    while(!q[0].empty())
        q[0].pop();
    while(!q[1].empty())
        q[1].pop();
    memset(dist,-1,sizeof(dist));
    memset(vis,-1,sizeof(vis));
    dist[x*3+y][0]=0;
    vis[x*3+y][0]=0;
    q[0].push(Node(0,x*3+y,0));
    for(int i=0;i<9;++i)
        if(goal[i]==0){
            dfs(0,i);
            break;
        }
}

int getv(int p,int s)
{
    for(int i=1;i<=8-p;++i)
        s/=6;
    return s%6;
}

int bfs(int id,int step)
{
    while(!q[id].empty())
    {
        Node u=q[id].top();
        if(u.t>step)
            return -1;
        q[id].pop();

        if(vis[u.n][u.s]==!id)
            return u.t;

        int gg[9];
        int x=u.n/3,y=u.n%3;
        for(int i=0;i<4;++i){
            int nx=x+d[i][0],ny=y+d[i][1];
            if(nx<0||nx>2||ny<0||ny>2)
                continue;

            int s=u.s;
            for(int j=8;j>=0;--j){
                if(j==u.n)
                    gg[j]=-1;
                else{
                    gg[j]=s%6;
                    s/=6;
                }
            }
            gg[u.n]=p[gg[nx*3+ny]][i];
            gg[nx*3+ny]=-1;
            int sta=0,cnt=0;
            for(int j=0;j<9;++j)
                if(gg[j]!=-1){
                    sta=sta+ss[7-cnt]*gg[j];
                    ++cnt;
                }
            if(vis[nx*3+ny][sta]!=id){
                if(vis[nx*3+ny][sta]==-1){
                    vis[nx*3+ny][sta]=id;
                    dist[nx*3+ny][sta]=u.t+1;
                    q[id].push(Node(u.t+1,nx*3+ny,sta));
                }
                else
                    return u.t+1+dist[nx*3+ny][sta];
            }
        }
    }
    return -1;
}

int solve()
{
    int step=0;
    while(!q[0].empty()||!q[1].empty()){
        if(step>30)
            return -1;
        if(!q[0].empty()&&step<=21){
            int k=bfs(0,step);
            if(k>30)
                return -1;
            if(k!=-1)
                return k;
        }
        if(!q[1].empty()&&step<=9){
            int k=bfs(1,step);
            if(k>30)
                return -1;
            if(k!=-1)
                return k;
        }
        ++step;
    }
    return -1;
}

int main()
{
    //freopen("UVA-1604 Cubic Eight-Puzzle.txt","r",stdin);
    mp[‘E‘]=0,mp[‘W‘]=1,mp[‘R‘]=2,mp[‘B‘]=3;
    int x,y,gx,gy;
    char s[2];
    while(scanf("%d%d",&y,&x)&&(x+y))
    {
        --x,--y;
        for(int i=0;i<9;++i){
            scanf("%s",s);
            goal[i]=mp[s[0]];
        }
        init(x,y);
        printf("%d\n",solve());
    }
    return 0;
}

  

时间: 2024-10-29 19:07:10

UVA-1604 Cubic Eight-Puzzle (双向BFS+状态压缩+限制搜索层数)的相关文章

hdu--1429--胜利大逃亡(续) (bfs+状态压缩)

胜利大逃亡(续) Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 8560    Accepted Submission(s): 3071 Problem Description Ignatius再次被魔王抓走了(搞不懂他咋这么讨魔王喜欢)-- 这次魔王汲取了上次的教训,把Ignatius关在一个n*m的地牢里,并在地牢的某些地方安装了带

ACM/ICPC 之 BFS+状态压缩(POJ1324(ZOJ1361))

求一条蛇到(1,1)的最短路长,题目不简单,状态较多,需要考虑状态压缩,ZOJ的数据似乎比POj弱一些 POJ1324(ZOJ1361)-Holedox Moving 题意:一条已知初始状态的蛇,求其到(1,1)的最短路长 题解:开始做的时候用BFS暴力做了一次,结果RE了,后来看了其他的题解和discuss才转向状态压缩.也看到有人用A*做出来了. 现在简要介绍一下状态压缩的思路: 由于蛇身最长只有8,可以利用两条相邻蛇身坐标确定其相对方向(四个方向),两位二进制可以表示 这样 一个蛇头坐标+

hdoj 5094 Maze 【BFS + 状态压缩】 【好多坑】

Maze Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 100000/100000 K (Java/Others) Total Submission(s): 901    Accepted Submission(s): 314 Problem Description This story happened on the background of Star Trek. Spock, the deputy captain of St

hdu2209翻纸牌游戏(bfs+状态压缩)

Problem Description 有一种纸牌游戏,很有意思,给你N张纸牌,一字排开,纸牌有正反两面,开始的纸牌可能是一种乱的状态(有些朝正,有些朝反),现在你需要整理这些纸牌.但是麻烦的是,每当你翻一张纸牌(由正翻到反,或者有反翻到正)时,他左右两张纸牌(最左边和最右边的纸牌,只会影响附近一张)也必须跟着翻动,现在给你一个乱的状态,问你能否把他们整理好,使得每张纸牌都正面朝上,如果可以,最少需要多少次操作. Input 有多个case,每个case输入一行01符号串(长度不超过20),1表

poj 1753 Flip Game(bfs状态压缩 或 dfs枚举)

Description Flip game is played on a rectangular 4x4 field with two-sided pieces placed on each of its 16 squares. One side of each piece is white and the other one is black and each piece is lying either it's black or white side up. Each round you f

hdu 4856 Tunnels(bfs+状态压缩)

题目链接:hdu 4856 Tunnels 题目大意:给定一张图,图上有M个管道,管道给定入口和出口,单向,现在有人想要体验下这M个管道,问最短需要移动的距离,起点未定. 解题思路:首先用bfs处理出两两管道之间移动的距离,然后后用状态压缩求出最短代价,dp[i][j],i表示的已经走过的管道,j是当前所在的管道. #include <cstdio> #include <cstring> #include <queue> #include <algorithm&g

HDU 3247 Resource Archiver (AC自己主动机 + BFS + 状态压缩DP)

题目链接:Resource Archiver 解析:n个正常的串.m个病毒串,问包括全部正常串(可重叠)且不包括不论什么病毒串的字符串的最小长度为多少. AC自己主动机 + bfs + 状态压缩DP 用最短路预处理出状态的转移.能够优化非常多 AC代码: #include <cstdio> #include <iostream> #include <cstring> #include <algorithm> #include <queue> us

hdu1254推箱子 (BFS+BFS+状态压缩)

推箱子 Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 5089 Accepted Submission(s): 1421 Problem Description 推箱子是一个很经典的游戏.今天我们来玩一个简单版本.在一个M*N的房间里有一个箱子和一个搬运工,搬运工的工作就是把箱子推到指定的位置,注意,搬运工只能推箱子而不能拉箱子,因此如果箱

HDU 3247 Resource Archiver (AC自动机 + BFS + 状态压缩DP)

题目链接:Resource Archiver 解析:n个正常的串,m个病毒串,问包含所有正常串(可重叠)且不包含任何病毒串的字符串的最小长度为多少. AC自动机 + bfs + 状态压缩DP 用最短路预处理出状态的转移.可以优化很多 AC代码: #include <cstdio> #include <iostream> #include <cstring> #include <algorithm> #include <queue> using n